#include <iostream>
#include <omp.h>

using namespace std;

int main()	{
	int numThreads = omp_get_max_threads();
	cout<<numThreads<<" threads to be spawned..."<<endl;
	#pragma omp parallel
	{
		#pragma omp critical
		cout<<"Hello from thread "<<omp_get_thread_num()<<endl;
	}
	cout<<"Threads finished."<<endl<<endl;

	omp_set_num_threads(12);
	#pragma omp parallel
	{
		#pragma omp critical
		cout<<"Goodbye from thread "<<omp_get_thread_num()<<endl;
	}

	return 0;
}

